Index: trunk/zoo-project/zoo-kernel/service.c
===================================================================
--- trunk/zoo-project/zoo-kernel/service.c	(revision 966)
+++ trunk/zoo-project/zoo-kernel/service.c	(revision 967)
@@ -1480,21 +1485,21 @@
  * Free memory allocated for the registry
  *
- * @param r the registry
- */
-void freeRegistry(registry** r){
-  registry* lr=*r;
-  while(lr!=NULL){
-    services* s=lr->content;
-    free(lr->name);
-    while(s!=NULL){
-      service* s1=s->content;
-      s=s->next;
-      if(s1!=NULL){
-	freeService(&s1);
-	free(s1);
-	s1=NULL;
+ * @param prReg the registry
+ */
+void freeRegistry(registry** prReg){
+  registry* prLocalRef=*prReg;
+  while(prLocalRef!=NULL){
+    services* psServ=prLocalRef->content;
+    free(prLocalRef->name);
+    while(psServ!=NULL){
+      service* psServ1=psServ->content;
+      psServ=psServ->next;
+      if(psServ1!=NULL){
+	freeService(&psServ1);
+	free(psServ1);
+	psServ1=NULL;
       }
     }
-    lr=lr->next;
+    prLocalRef=prLocalRef->next;
   }    
 }
@@ -1503,22 +1508,22 @@
  * Access a service in the registry
  *
- * @param r the registry
- * @param level the regitry to search ("concept", "generic" or "implementation")
- * @param sname the service name
+ * @param prReg the registry
+ * @param pcLevel the regitry to search ("concept", "generic" or "implementation")
+ * @param pcName the service name
  * @return the service pointer if a corresponding service was found or NULL
  */
-service* getServiceFromRegistry(registry* r,char  *level,char* sname){
-  registry *lr=r;
-  while(lr!=NULL){
-    if(strcasecmp(lr->name,level)==0){
-      services* s=lr->content;
-      while(s!=NULL){
-	if(s->content!=NULL && strcasecmp(s->content->name,sname)==0)
-	  return s->content;
-	s=s->next;
+service* getServiceFromRegistry(registry* prReg,char  *pcLevel,char* pcName){
+  registry *prLocalRef=prReg;
+  while(prLocalRef!=NULL){
+    if(strcasecmp(prLocalRef->name,pcLevel)==0){
+      services* psServ=prLocalRef->content;
+      while(psServ!=NULL){
+	if(psServ->content!=NULL && strcasecmp(psServ->content->name,pcName)==0)
+	  return psServ->content;
+	psServ=psServ->next;
       }
       break;
     }
-    lr=lr->next;
+    prLocalRef=prLocalRef->next;
   }
   return NULL;
@@ -1528,18 +1533,18 @@
  * Apply inheritance to an out map from a reference in map
  *
- * @param out the map to update
- * @param in the reference map (containing inherited properties)
- */
-void inheritMap(map** out,map* in){
-  map* content=in;
-  if((*out)==NULL){
-    addMapToMap(out,in);
+ * @param ppmOut the map to update
+ * @param pmIn the reference map (containing inherited properties)
+ */
+void inheritMap(map** ppmOut,map* pmIn){
+  map* pmContent=pmIn;
+  if((*ppmOut)==NULL){
+    addMapToMap(ppmOut,pmIn);
     return;
   }
-  while(content!=NULL){
-    map* cmap=getMap(*out,content->name);
-    if(cmap==NULL)
-      addToMap(*out,content->name,content->value);
-    content=content->next;
+  while(pmContent!=NULL){
+    map* pmCurrent=getMap(*ppmOut,pmContent->name);
+    if(pmCurrent==NULL)
+      addToMap(*ppmOut,pmCurrent->name,pmCurrent->value);
+    pmCurrent=pmCurrent->next;
   }
 }
@@ -1548,20 +1553,20 @@
  * Apply inheritance to an out iotype from a reference in iotype
  * 
- * @param out the iotype to update
- * @param in the reference iotype (containing inherited properties)
- */
-void inheritIOType(iotype** out,iotype* in){
-  iotype* io=in;
-  iotype* oio=*out;
-  if(io!=NULL){
-    if(*out==NULL){
-      *out=(iotype*)malloc(IOTYPE_SIZE);
-      (*out)->content=NULL;
-      addMapToMap(&(*out)->content,io->content);
-      (*out)->next=NULL;
-      oio=*out;
-      inheritIOType(&oio->next,io->next);
+ * @param ppiotOut the iotype to update
+ * @param piotIn the reference iotype (containing inherited properties)
+ */
+void inheritIOType(iotype** ppiotOut,iotype* piotIn){
+  iotype* piotInCurosor=piotIn;
+  iotype* ppiotOutCursor=*ppiotOut;
+  if(piotInCurosor!=NULL){
+    if(*ppiotOut==NULL){
+      *ppiotOut=(iotype*)malloc(IOTYPE_SIZE);
+      (*ppiotOut)->content=NULL;
+      addMapToMap(&(*ppiotOut)->content,piotInCurosor->content);
+      (*ppiotOut)->next=NULL;
+      ppiotOutCursor=*ppiotOut;
+      inheritIOType(&ppiotOutCursor->next,piotInCurosor->next);
     }else{
-      inheritIOType(&oio->next,io->next);
+      inheritIOType(&ppiotOutCursor->next,piotInCurosor->next);
     }
   }
@@ -1571,30 +1576,30 @@
  * Apply inheritance to an out elements from a reference in elements
  * 
- * @param out the elements to update
- * @param in the reference elements (containing inherited properties)
- */
-void inheritElements(elements** out,elements* in){
-  elements* content=in;
-  while(content!=NULL && *out!=NULL){
-    elements* cmap=getElements(*out,content->name);
-    if(cmap==NULL)
-      addToElements(out,content);
+ * @param ppeOut the elements to update
+ * @param peIn the reference elements (containing inherited properties)
+ */
+void inheritElements(elements** ppeOut,elements* peIn){
+  elements* peContent=peIn;
+  while(peContent!=NULL && *ppeOut!=NULL){
+    elements* peCurrent=getElements(*ppeOut,peContent->name);
+    if(peCurrent==NULL)
+      addToElements(ppeOut,peContent);
     else{
-      inheritMap(&cmap->content,content->content);
-      inheritMap(&cmap->metadata,content->metadata);
-      if(cmap->format==NULL && content->format!=NULL)
-	cmap->format=zStrdup(content->format);
-      inheritIOType(&cmap->defaults,content->defaults);
-      if(cmap->supported==NULL)
-	inheritIOType(&cmap->supported,content->supported);
+      inheritMap(&peCurrent->content,peContent->content);
+      inheritMap(&peCurrent->metadata,peContent->metadata);
+      if(peCurrent->format==NULL && peContent->format!=NULL)
+	peCurrent->format=zStrdup(peContent->format);
+      inheritIOType(&peCurrent->defaults,peContent->defaults);
+      if(peCurrent->supported==NULL)
+	inheritIOType(&peCurrent->supported,peContent->supported);
       else{
-	iotype* p=content->supported;
-	while(p!=NULL){
-	  addMapToIoType(&cmap->supported,p->content);
-	  p=p->next;
+	iotype* piotTmp=peContent->supported;
+	while(piotTmp!=NULL){
+	  addMapToIoType(&peCurrent->supported,piotTmp->content);
+	  piotTmp=piotTmp->next;
 	}
       }
     }
-    content=content->next;
+    peContent=peContent->next;
   }
 }
@@ -1603,34 +1608,34 @@
  * Apply inheritance to a service based on a registry
  * 
- * @param r the registry storing profiles hierarchy
- * @param s the service to update depending on its inheritance
- */
-void inheritance(registry *r,service** s){
-  service* ls=*s;
+ * @param prReg the registry storing profiles hierarchy
+ * @param psServ the service to update depending on its inheritance
+ */
+void inheritance(registry *prReg,service** psServ){
+  service* psCursor=*psServ;
   map *profile,*level;
-  if(r==NULL)
+  if(prReg==NULL)
     return;
-  if(ls==NULL || ls->content==NULL)
+  if(psCursor==NULL || psCursor->content==NULL)
     return;
-  profile=getMap(ls->content,"extend");
-  level=getMap(ls->content,"level");
+  profile=getMap(psCursor->content,"extend");
+  level=getMap(psCursor->content,"level");
   if(profile!=NULL&&level!=NULL){
     service* s1;
     if(strncasecmp(level->value,"profile",7)==0)
-      s1=getServiceFromRegistry(r,(char*)"generic",profile->value);
+      s1=getServiceFromRegistry(prReg,(char*)"generic",profile->value);
     else
-      s1=getServiceFromRegistry(r,level->value,profile->value);
+      s1=getServiceFromRegistry(prReg,level->value,profile->value);
       
-    inheritMap(&ls->content,s1->content);
-    inheritMap(&ls->metadata,s1->metadata);
-    if(ls->inputs==NULL && s1->inputs!=NULL){
-      ls->inputs=dupElements(s1->inputs);
+    inheritMap(&psCursor->content,s1->content);
+    inheritMap(&psCursor->metadata,s1->metadata);
+    if(psCursor->inputs==NULL && s1->inputs!=NULL){
+      psCursor->inputs=dupElements(s1->inputs);
     }else{
-      inheritElements(&ls->inputs,s1->inputs);
-    }
-    if(ls->outputs==NULL && s1->outputs!=NULL){
-      ls->outputs=dupElements(s1->outputs);
+      inheritElements(&psCursor->inputs,s1->inputs);
+    }
+    if(psCursor->outputs==NULL && s1->outputs!=NULL){
+      psCursor->outputs=dupElements(s1->outputs);
     }else
-      inheritElements(&ls->outputs,s1->outputs);
+      inheritElements(&psCursor->outputs,s1->outputs);
   }
 }
@@ -1639,35 +1644,35 @@
  * Convert a maps to a char*** (only used for Fortran support)
  *
- * @param m the maps to convert
- * @param c the resulting array
- */
-void mapsToCharXXX(maps* m,char*** c){
-  maps* tm=m;
+ * @param pmsMap the maps to convert
+ * @param pppcValues the resulting array
+ */
+void mapsToCharXXX(maps* pmsMap,char*** pppcValues){
+  maps* pmsCursor=pmsMap;
   int i=0;
   int j=0;
-  char tmp[10][30][1024];
-  memset(tmp,0,1024*10*10);
-  while(tm!=NULL){
-    map* tc=tm->content;
+  char aaacTmp[10][30][1024];
+  memset(aaacTmp,0,1024*10*10);
+  while(pmsCursor!=NULL){
+    map* pmContent=pmsCursor->content;
     if(i>=10)
       break;
-    strcpy(tmp[i][j],"name");
+    strcpy(aaacTmp[i][j],"name");
     j++;
-    strcpy(tmp[i][j],tm->name);
+    strcpy(aaacTmp[i][j],pmsCursor->name);
     j++;
-    while(tc!=NULL){
+    while(pmContent!=NULL){
       if(j>=30)
 	break;
-      strcpy(tmp[i][j],tc->name);
+      strcpy(aaacTmp[i][j],pmContent->name);
       j++;
-      strcpy(tmp[i][j],tc->value);
+      strcpy(aaacTmp[i][j],pmContent->value);
       j++;
-      tc=tc->next;
-    }
-    tm=tm->next;
+      pmContent=pmContent->next;
+    }
+    pmsCursor=pmsCursor->next;
     j=0;
     i++;
   }
-  memcpy(c,tmp,10*10*1024);
+  memcpy(pppcValues,aaacTmp,10*10*1024);
 }
 
@@ -1675,29 +1680,29 @@
  * Convert a char*** to a maps (only used for Fortran support)
  *
- * @param c the array to convert
- * @param m the resulting maps
- */
-void charxxxToMaps(char*** c,maps**m){
-  maps* trorf=*m;
+ * @param pppcValues the array to convert
+ * @param ppmsMaps the resulting maps
+ */
+void charxxxToMaps(char*** pppcValues,maps** ppmsMaps){
+  maps* pmsCursor=*ppmsMaps;
   int i,j;
-  char tmp[10][30][1024];
-  memcpy(tmp,c,10*30*1024);
+  char aaaTmp[10][30][1024];
+  memcpy(aaaTmp,pppcValues,10*30*1024);
   for(i=0;i<10;i++){
-    if(strlen(tmp[i][1])==0)
+    if(strlen(aaaTmp[i][1])==0)
       break;
-    trorf->name=tmp[i][1];
-    trorf->content=NULL;
-    trorf->next=NULL;
+    pmsCursor->name=aaaTmp[i][1];
+    pmsCursor->content=NULL;
+    pmsCursor->next=NULL;
     for(j=2;j<29;j+=2){
-      if(strlen(tmp[i][j+1])==0)
+      if(strlen(aaaTmp[i][j+1])==0)
 	break;
-      if(trorf->content==NULL)
-	trorf->content=createMap(tmp[i][j],tmp[i][j+1]);
+      if(pmsCursor->content==NULL)
+	pmsCursor->content=createMap(aaaTmp[i][j],aaaTmp[i][j+1]);
       else
-	addToMap(trorf->content,tmp[i][j],tmp[i][j+1]);
-    }
-    trorf=trorf->next;
-  }
-  m=&trorf;
+	addToMap(pmsCursor->content,aaaTmp[i][j],aaaTmp[i][j+1]);
+    }
+    pmsCursor=pmsCursor->next;
+  }
+  ppmsMaps=&pmsCursor;
 }
 
@@ -1705,9 +1710,9 @@
  * Verify that a map has a value
  *
- * @param map pointer to map that should be checked
+ * @param pmMap pointer to map that should be checked
  * @return true if map has a value or false if value is missing/empty/NULL
  */
-bool nonempty(map* map) {
-	return (map != NULL && map->value != NULL && strlen(map->value) > 0 && strcmp(map->value, "NULL") != 0);
+bool nonempty(map* pmMap) {
+  return (pmMap != NULL && pmMap->value != NULL && strlen(pmMap->value) > 0 && strcmp(pmMap->value, "NULL") != 0);
 }
 
@@ -1716,16 +1721,16 @@
  * data structure, and obtain that value
  *
- * @param source pointer to maps structure
- * @param node name of maps node to search
- * @param key name of map node to find
- * @param kvp address to the map* if it exists, otherwise NULL
+ * @param pmsSource pointer to maps structure
+ * @param pccNode name of maps node to search
+ * @param pccKey name of map node to find
+ * @param ppmKvp address to the map* if it exists, otherwise NULL
  * @return true if map has a value or false if value is missing/NULL
  *
  * @note The map assigned to kvp is owned by the source maps
  */
-bool hasvalue(maps* source, const char* node, const char* key, map** kvp) {
-	*kvp = getMapFromMaps(source, node, key);
-	return (*kvp != NULL && (*kvp)->value != NULL &&
-		strlen((*kvp)->value) > 0 && strcmp((*kvp)->value, "NULL") != 0);
+bool hasvalue(maps* pmsSource, const char* pccNode, const char* pccKey, map** ppmKvp) {
+  *ppmKvp = getMapFromMaps(pmsSource, pccNode, pccKey);
+  return (*ppmKvp != NULL && (*ppmKvp)->value != NULL &&
+	  strlen((*ppmKvp)->value) > 0 && strcmp((*ppmKvp)->value, "NULL") != 0);
 }
 
@@ -1733,76 +1738,82 @@
  * Set error message in configuration maps
  *
- * @param conf reference to configuration maps
- * @param service name of service
- * @param exc WPSException code
- * @param message exception text (default: exception text in WPS specification)
- */
-void setErrorMessage(maps*& conf, const char* service, WPSException exc, const char* message) {
-
-	if (message == NULL) {
-		message = WPSExceptionText[exc];
-	}
-
-	size_t len = strlen(service) + strlen(": ") + strlen(message) + strlen(": ") + strlen(WPSExceptionCode[exc]) + 16;
-	char* msg = (char*)malloc(len * sizeof(char));
-
-	if (msg != NULL) {
-		snprintf(msg, len * sizeof(char), "\n%s: %s: %s\n", service, message, WPSExceptionCode[exc]);
-		setMapInMaps(conf, "lenv", "message", msg);
-		free(msg);
-	}
-}
-
-void logMessage(const char* source, const char* function, int line, const char* file, const char* message) { //, const char* source, const char* function, int line) {
-
-	size_t msglen = 512;
-	const char empty[] = "";
-
-	FILE* log;
-
-	// system time, process time [nanoseconds]   
-	unsigned long long sys_t, proc_t;
-
-	// processor time consumed by the program:
-	clock_t t = clock();
-
-	// system time:
-	std::chrono::system_clock::time_point now = std::chrono::system_clock::now();
-
-	std::time_t now_t = std::chrono::system_clock::to_time_t(now);
-	std::tm* tm = localtime(&now_t);
-	char* str = asctime(tm);
-	str[strlen(str) - 1] = '\0'; // remove newline
-
-	sys_t = std::chrono::duration_cast<std::chrono::nanoseconds>(now.time_since_epoch()).count();
-	//proc_t = (unsigned long long)(1.0e9*t/CLOCKS_PER_SEC);
-	proc_t = t;
-
-	if (message != NULL) {
-		msglen += strlen(message);
-	}
-	else {
-		message = empty;
-	}
-	//getLastErrorMessage(); // cgiScriptName  
-	char* text = (char*)malloc(sizeof(char)*msglen);
-
-	snprintf(text, msglen, "pid: %d %s line %d %s() %s systime: %lld ns ticks: %lld %s\n",
-		zGetpid(), source, line, function, str, sys_t, proc_t, message); // __FILE__ __LINE__ __func__ //
-
-	if (file != NULL && (log = fopen(file, "a+")) != NULL) {
-		fputs(text, log);
-		fclose(log);
-	}
-	else {
+ * @param pmsaConf reference to configuration maps
+ * @param pccService name of service
+ * @param weExc WPSException code
+ * @param pccMessage exception text (default: exception text in WPS specification)
+ */
+void setErrorMessage(maps*& pmsaConf, const char* pccService, WPSException weExc, const char* pccMessage) {
+  if (pccMessage == NULL) {
+    pccMessage = WPSExceptionText[weExc];
+  }
+  size_t len = strlen(pccService) + strlen(": ") + strlen(pccMessage) + strlen(": ") + strlen(WPSExceptionCode[weExc]) + 16;
+  char* pcMsg = (char*)malloc(len * sizeof(char));
+  if (pcMsg != NULL) {
+    snprintf(pcMsg, len * sizeof(char), "\n%s: %s: %s\n", pccService, pccMessage, WPSExceptionCode[weExc]);
+    setMapInMaps(pmsaConf, "lenv", "message", pcMsg);
+    free(pcMsg);
+  }
+}
+
+/**
+ * Print debug message
+ *
+ * @param pccSource the file invoking the function
+ * @param pccFunction the function calling for logMessage
+ * @param iLine the line number
+ * @param pccFile the file to log informations
+ * @param pccMessage the message to be print
+ */
+void logMessage(const char* pccSource, const char* pccFunction, int iLne, const char* pccFile, const char* pccMessage) { //, const char* source, const char* function, int line) {
+
+  size_t msglen = 512;
+  const char empty[] = "";
+
+  FILE* pfLog;
+
+  // system time, process time [nanoseconds]   
+  unsigned long long sys_t, proc_t;
+
+  // processor time consumed by the program:
+  clock_t t = clock();
+
+  // system time:
+  std::chrono::system_clock::time_point now = std::chrono::system_clock::now();
+
+  std::time_t now_t = std::chrono::system_clock::to_time_t(now);
+  std::tm* tm = localtime(&now_t);
+  char* pcStr = asctime(tm);
+  pcStr[strlen(pcStr) - 1] = '\0'; // remove newline
+
+  sys_t = std::chrono::duration_cast<std::chrono::nanoseconds>(now.time_since_epoch()).count();
+  //proc_t = (unsigned long long)(1.0e9*t/CLOCKS_PER_SEC);
+  proc_t = t;
+
+  if (pccMessage != NULL) {
+    msglen += strlen(pccMessage);
+  }
+  else {
+    pccMessage = empty;
+  }
+  //getLastErrorMessage(); // cgiScriptName  
+  char* pcText = (char*)malloc(sizeof(char)*msglen);
+
+  snprintf(pcText, msglen, "pid: %d %s line %d %s() %s systime: %lld ns ticks: %lld %s\n",
+	   zGetpid(), pccSource, iLne, pccFunction, pcStr, sys_t, proc_t, pccMessage); // __FILE__ __LINE__ __func__ //
+
+  if (pccFile != NULL && (pfLog = fopen(pccFile, "a+")) != NULL) {
+    fputs(pcText, pfLog);
+    fclose(pfLog);
+  }
+  else {
 #ifdef MSG_LOG_FILE
-		if ((log = fopen(MSG_LOG_FILE, "a+")) != NULL) {
-			fputs(text, log);
-			fclose(log);
-		}
+    if ((pfLog = fopen(MSG_LOG_FILE, "a+")) != NULL) {
+      fputs(pcText, pfLog);
+      fclose(pfLog);
+    }
 #endif
-	}
-
-	if (text != NULL) free(text);
+  }
+
+  if (pcText != NULL) free(pcText);
 }
 
@@ -1815,15 +1826,15 @@
 #ifdef WIN32
 #ifndef USE_MS
-char *strcasestr (char const *a, char const *b)
+char *strcasestr (char const *pccA, char const *pccB)
   {
-    char *x = zStrdup (a);
-    char *y = zStrdup (b);
+    char *pcX = zStrdup (pccA);
+    char *pcY = zStrdup (pccB);
  
-      x = _strlwr (x);
-      y = _strlwr (y);
-    char *pos = strstr (x, y);
-    char *ret = pos == NULL ? NULL : (char *) (a + (pos - x));
-      free (x);
-      free (y);
+      pcX = _strlwr (pcX);
+      pcY = _strlwr (pcY);
+    char *pos = strstr (pcX, pcY);
+    char *ret = pos == NULL ? NULL : (char *) (pccA + (pos - pcX));
+      free (pcX);
+      free (pcY);
       return ret;
   };
@@ -1843,15 +1854,15 @@
  * The memory should be deallocated by calling freeMap.
  */
-char* allocateMapValue(map* node, size_t num_bytes)
+char* allocateMapValue(map* pmNode, size_t sNumBytes)
 {
-	if (node == NULL) {
-		return NULL;
-	}
-
-	if (node->value != NULL) {
-		free(node->value);
-	}
-	node->value = (char*) malloc(num_bytes);
+  if (pmNode == NULL) {
+    return NULL;
+  }
+
+  if (pmNode->value != NULL) {
+    free(pmNode->value);
+  }
+  pmNode->value = (char*) malloc(sNumBytes);
 		
-	return node->value;
-}
+  return pmNode->value;
+}
Index: trunk/zoo-project/zoo-kernel/service_internal_python.c
===================================================================
--- trunk/zoo-project/zoo-kernel/service_internal_python.c	(revision 966)
+++ trunk/zoo-project/zoo-kernel/service_internal_python.c	(revision 967)
@@ -468,5 +468,5 @@
   while(tmp!=NULL){
     PyObject* name=PyString_FromString(tmp->name);
-    if(strcasecmp(tmp->name,"value")==0 && strlen(tmp->value)>0) {
+    if(strcasecmp(tmp->name,"value")==0) {
       if(isArray!=NULL){
 	map* len=getMap(tmp,"length");
@@ -492,6 +492,9 @@
 	      lvalue=PyString_FromString(vMap->value);
 	    }
-	    else{    
-	      lvalue=PyString_FromStringAndSize(vMap->value,atoi(sMap->value));
+	    else{
+	      if(strlen(vMap->value)>0)
+		lvalue=PyString_FromStringAndSize(vMap->value,atoi(sMap->value));
+	      else
+		lvalue=Py_None;
 	    }
 	    if(sMap!=NULL){
@@ -553,5 +556,9 @@
       }
       else if(size!=NULL && useFile==NULL){
-	PyObject* value=PyString_FromStringAndSize(tmp->value,atoi(size->value));
+	PyObject* value;
+	if(strlen(tmp->value)>0)
+	  value=PyString_FromStringAndSize(tmp->value,atoi(size->value));
+	else
+	  value=Py_None;
 	if(PyDict_SetItem(res,name,value)<0){
 	  Py_DECREF(value);
@@ -572,5 +579,5 @@
     }
     else{
-      if(PyDict_GetItem(res,name)==NULL && strlen(tmp->value)>0){
+      if(PyDict_GetItem(res,name)==NULL){
 	PyObject* value=PyString_FromString(tmp->value);
 	if(PyDict_SetItem(res,name,value)<0){
